
AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )
include( 'shared.lua' )

/*---------------------------------------------------------
   Name: Initialize
---------------------------------------------------------*/
function ENT:Initialize()

	self:PhysicsInit( SOLID_VPHYSICS )
	self:SetMoveType( MOVETYPE_VPHYSICS )
	self:SetSolid( SOLID_VPHYSICS ) 
	
	self:SetModel("models/gibs/hgibs.mdl")
	
	self:PhysicsInit( SOLID_VPHYSICS )
	self:SetMoveType( MOVETYPE_VPHYSICS ) 
	self:SetSolid( SOLID_VPHYSICS )
	
	local phys = self:GetPhysicsObject()
	if phys:IsValid() then
		phys:Wake()
		phys:SetVelocity(Vector(0,0,-5))
	end
	
	self.Activ8 = Sound("buttons/button9.wav")
	self.Deactiv8 = Sound("physics/metal/metal_solid_impact_hard1.wav")
	self.Spawning = false
	
end

function ENT:SpawnFunction( ply, tr )

	if ( !tr.Hit ) then return end
	
	local SpawnPos = tr.HitPos + tr.HitNormal * 20
	
	local ent = ents.Create( "sent_zombie_spawner" )
	ent:SetPos( SpawnPos )
	ent:Spawn()
	ent:Activate()
	
	return ent
	
end

/*---------------------------------------------------------
   Name: Think
---------------------------------------------------------*/
function ENT:Think()
	if self.Usable then
		if self.Usable < CurTime() then
			self.Usable = nil
		end
	end
	if self.Spawning then
		if not self.Timer then
			self.Timer = CurTime() + 5
			local zomb = ents.Create(ChooseRandom({"npc_zombie_headcrabless","npc_fast_headcrabless","npc_poison_headcrabless"}))
			zomb:SetPos(self:GetPos() + Vector(math.random(-10,10),math.random(-10,10),50))
			zomb:Spawn()
		elseif CurTime() > self.Timer then
			self.Timer = nil
		end
	end
end 

function ENT:Use(ply,calls)
	if self.Usable then return end
	self.Usable = CurTime() + 1
	self.Spawning = not self.Spawning
	if self.Spawning == true then
		self:EmitSound(self.Activ8)
	else
		self:EmitSound(self.Deactiv8)
	end
end

 /*---------------------------------------------------------
   Name: takedamage
---------------------------------------------------------*/
function ENT:OnTakeDamage( dmginfo )	

end

/*---------------------------------------------------------
   Name: PhysicsCollide
---------------------------------------------------------*/
function ENT:PhysicsCollide( data, physobj )

end